% BalticApp
% Linear regression (blue flag)

clear
clc

rng(179424673);
global B_backup;


%% Data transformation 
cd('C:\Users\Admin\Documents\Baltic\MXL')

% Denmark
DK = load('DK_mxl_cs.mat');
n_site = length(unique(DK.DATA.bwid));

choice_name = [string(DK.DATA.bwid(1));string(DK.Results.MXL_d.R_out(4:4+n_site-2,1))];
choice_asc = [0;str2double(string(DK.Results.MXL_d.R_out(4:4+n_site-2,3)))];
choice_tc = exp(str2double(string(DK.Results.MXL_d.R_out(4+n_site-1,3)))+((str2double(string(DK.Results.MXL_d.R_out(4+n_site-1,7))))^2)/2);
choice_tc = repelem(choice_tc,n_site)';

DK_data = [string(DK.DATA.bwid(1:n_site)),...
    choice_name,...
    choice_asc,...
    DK.DATA.blue_flag(1:n_site),...
    DK.DATA.POP3(1:n_site),...
    DK.DATA.POP6(1:n_site),...
    DK.DATA.POP10(1:n_site),...
    DK.DATA.comp(1:n_site),...
    choice_tc,...
    DK.DATA.concEC(1:n_site),...
    DK.DATA.concIE(1:n_site)];
sum(DK_data(:,1)==DK_data(:,2))/n_site

% Estonia
EE = load('EE_mxl_cs.mat');
n_site = length(unique(EE.DATA.bwid));

choice_name = [string(EE.DATA.bwid(1));string(EE.Results.MNL.R_out(4:4+n_site-2,1))];
choice_asc = [0;str2double(string(EE.Results.MNL.R_out(4:4+n_site-2,3)))];
choice_tc = str2double(string(EE.Results.MNL.R_out(4+n_site-1,3)));
choice_tc = repelem(choice_tc,n_site)';

EE_data = [string(EE.DATA.bwid(1:n_site)),...
    choice_name,...
    choice_asc,...
    EE.DATA.blue_flag(1:n_site),...
    EE.DATA.POP3(1:n_site),...
    EE.DATA.POP6(1:n_site),...
    EE.DATA.POP10(1:n_site),...
    EE.DATA.comp(1:n_site),...
    choice_tc,...
    EE.DATA.concEC(1:n_site),...
    EE.DATA.concIE(1:n_site)];
sum(EE_data(:,1)==EE_data(:,2))/n_site

% Finland
FI = load('FI_mxl_cs.mat');
n_site = length(unique(FI.DATA.BWID));

choice_name = [string(FI.DATA.BWID(1));string(FI.Results.MXL_d.R_out(4:4+n_site-2,1))];
choice_asc = [0;str2double(string(FI.Results.MXL_d.R_out(4:4+n_site-2,3)))];
choice_tc = exp(str2double(string(FI.Results.MXL_d.R_out(4+n_site-1,3)))+((str2double(string(FI.Results.MXL_d.R_out(4+n_site-1,7))))^2)/2);
choice_tc = repelem(choice_tc,n_site)';

FI_data = [string(FI.DATA.BWID(1:n_site)),...
    choice_name,...
    choice_asc,...
    FI.DATA.blue_flag(1:n_site),...
    FI.DATA.POP3(1:n_site),...
    FI.DATA.POP6(1:n_site),...
    FI.DATA.POP10(1:n_site),...
    FI.DATA.comp(1:n_site),...
    choice_tc,...
    FI.DATA.concEC(1:n_site),...
    FI.DATA.concIE(1:n_site)];
sum(FI_data(:,1)==FI_data(:,2))/n_site

% Latvia
LV = load('LV_mxl_cs.mat');
n_site = length(unique(LV.DATA.bwid));

choice_name = [string(LV.DATA.bwid(1));string(LV.Results.MXL_d.R_out(4:4+n_site-2,1))];
choice_asc = [0;str2double(string(LV.Results.MXL_d.R_out(4:4+n_site-2,3)))];
choice_tc = exp(str2double(string(LV.Results.MXL_d.R_out(4+n_site-1,3)))+((str2double(string(LV.Results.MXL_d.R_out(4+n_site-1,7))))^2)/2);
choice_tc = repelem(choice_tc,n_site)';

LV_data = [string(LV.DATA.bwid(1:n_site)),...
    choice_name,...
    choice_asc,...
    LV.DATA.blue_flag(1:n_site),...
    LV.DATA.POP3(1:n_site),...
    LV.DATA.POP6(1:n_site),...
    LV.DATA.POP10(1:n_site),...
    LV.DATA.comp(1:n_site),...
    choice_tc,...
    LV.DATA.concEC(1:n_site),...
    LV.DATA.concIE(1:n_site)];
sum(LV_data(:,1)==LV_data(:,2))/n_site

% Lithuania
LT = load('LT_mxl_cs.mat');
n_site = length(unique(LT.DATA.bwid));

choice_name = [string(LT.DATA.bwid(1));string(LT.Results.MNL.R_out(4:4+n_site-2,1))];
choice_asc = [0;str2double(string(LT.Results.MNL.R_out(4:4+n_site-2,3)))];
choice_tc = str2double(string(LT.Results.MNL.R_out(4+n_site-1,3)));
choice_tc = repelem(choice_tc,n_site)';

LT_data = [string(LT.DATA.bwid(1:n_site)),...
    choice_name,...
    choice_asc,...
    LT.DATA.blue_flag(1:n_site),...
    LT.DATA.POP3(1:n_site),...
    LT.DATA.POP6(1:n_site),...
    LT.DATA.POP10(1:n_site),...
    LT.DATA.comp(1:n_site),...
    choice_tc,...
    LT.DATA.concEC(1:n_site),...
    LT.DATA.concIE(1:n_site)];
sum(LT_data(:,1)==LT_data(:,2))/n_site

% Poland
PL = load('PL_mxl_cs.mat');
n_site = length(unique(PL.DATA.bwid));

choice_name = [string(PL.DATA.bwid(1));string(PL.Results.MNL.R_out(4:4+n_site-2,1))];
choice_asc = [0;str2double(string(PL.Results.MNL.R_out(4:4+n_site-2,3)))];
choice_tc = str2double(string(PL.Results.MNL.R_out(4+n_site-1,3)));
choice_tc = repelem(choice_tc,n_site)';

PL_data = [string(PL.DATA.bwid(1:n_site)),...
    choice_name,...
    choice_asc,...
    PL.DATA.blue_flag(1:n_site),...
    PL.DATA.POP3(1:n_site),...
    PL.DATA.POP6(1:n_site),...
    PL.DATA.POP10(1:n_site),...
    PL.DATA.comp(1:n_site),...
    choice_tc,...
    PL.DATA.concEC(1:n_site),...
    PL.DATA.concIE(1:n_site)];
sum(PL_data(:,1)==PL_data(:,2))/n_site

% Sweden
SE = load('SE_mxl_cs.mat');
n_site = length(unique(SE.DATA.BWID));

choice_name = [string(SE.DATA.BWID(1));string(SE.Results.MXL_d.R_out(4:4+n_site-2,1))];
choice_asc = [0;str2double(string(SE.Results.MXL_d.R_out(4:4+n_site-2,3)))];
choice_tc = exp(str2double(string(SE.Results.MXL_d.R_out(4+n_site-1,3)))+((str2double(string(SE.Results.MXL_d.R_out(4+n_site-1,7))))^2)/2);
choice_tc = repelem(choice_tc,n_site)';

SE_data = [string(SE.DATA.BWID(1:n_site)),...
    choice_name,...
    choice_asc,...
    SE.DATA.blue_flag(1:n_site),...
    SE.DATA.POP3(1:n_site),...
    SE.DATA.POP6(1:n_site),...
    SE.DATA.POP10(1:n_site),...
    SE.DATA.comp(1:n_site),...
    choice_tc,...
    SE.DATA.concEC(1:n_site),...
    SE.DATA.concIE(1:n_site)];
sum(SE_data(:,1)==SE_data(:,2))/n_site

% Germany
DE = load('DE_mxl_cs.mat');
n_site = 30;

% some sites were not visited
sum(DE.DATA.DEMV_PR_1_0201) %1
sum(DE.DATA.DEMV_PR_1_0222) %5
sum(DE.DATA.DEMV_PR_1_0279) %15
sum(DE.DATA.DEMV_PR_1_0777) %20
sum(DE.DATA.DESH_PR_0007) %26
sum(DE.DATA.DESH_PR_0092) %30
sum(DE.DATA.DESH_PR_0146) %33
sum(DE.DATA.DESH_PR_0290) %37

missing_site = ones(38*1000,1);
missing_site(DE.DATA.SiteID=="DEMV_PR_1_0201")=0;
missing_site(DE.DATA.SiteID=="DEMV_PR_1_0222")=0;
missing_site(DE.DATA.SiteID=="DEMV_PR_1_0279")=0;
missing_site(DE.DATA.SiteID=="DEMV_PR_1_0777")=0;
missing_site(DE.DATA.SiteID=="DESH_PR_0007")=0;
missing_site(DE.DATA.SiteID=="DESH_PR_0092")=0;
missing_site(DE.DATA.SiteID=="DESH_PR_0146")=0;
missing_site(DE.DATA.SiteID=="DESH_PR_0290")=0;

aux_names = DE.DATA.SiteID(logical(missing_site));

choice_name = [string(aux_names(1));string(DE.Results.MNL.R_out(4:4+n_site-2,1))];
choice_asc = [0;str2double(string(DE.Results.MNL.R_out(4:4+n_site-2,3)))];
choice_tc = str2double(string(DE.Results.MNL.R_out(4+n_site-1,3)));
choice_tc = repelem(choice_tc,n_site)';

aux_blue_flag = DE.DATA.blue_flag(logical(missing_site));
aux_POP3 = DE.DATA.POP3(logical(missing_site));
aux_POP6 = DE.DATA.POP6(logical(missing_site));
aux_POP10 = DE.DATA.POP10(logical(missing_site));
aux_comp = DE.DATA.comp(logical(missing_site));
aux_concEC = DE.DATA.concEC(logical(missing_site));
aux_concIE = DE.DATA.concIE(logical(missing_site));

DE_data = [string(aux_names(1:n_site)),...
    choice_name,...
    choice_asc,...
    aux_blue_flag(1:n_site),...
    aux_POP3(1:n_site),...
    aux_POP6(1:n_site),...
    aux_POP10(1:n_site),...
    aux_comp(1:n_site),...
    choice_tc,...
    aux_concEC(1:n_site),...
    aux_concIE(1:n_site)];
sum(DE_data(:,1)==DE_data(:,2))/n_site



%%%%% 

% Alternative (country) specific constants
DK_data(:,end+1) = "DK";
FI_data(:,end+1) = "FI";
EE_data(:,end+1) = "EE";
DE_data(:,end+1) = "DE";
LV_data(:,end+1) = "LV";
LT_data(:,end+1) = "LT";
PL_data(:,end+1) = "PL";
SE_data(:,end+1) = "SE";


% Merging data
DATA_blue_flag = [DK_data;...
    FI_data;...
    EE_data;...
    DE_data;...
    LV_data;...
    LT_data;...
    PL_data;...
    SE_data];

DATA_blue_flag = array2table(DATA_blue_flag,'VariableNames',{'Site1', 'Site2', 'Asc_choice', 'Blue_flag', 'POP3', 'POP6', 'POP10', 'Comp', 'TC', 'concEC', 'concIE', 'Country'});
DATA_blue_flag.Asc_choice = double(DATA_blue_flag.Asc_choice);
DATA_blue_flag.Blue_flag = double(DATA_blue_flag.Blue_flag);
DATA_blue_flag.POP3 = double(DATA_blue_flag.POP3);
DATA_blue_flag.POP6 = double(DATA_blue_flag.POP6);
DATA_blue_flag.POP10 = double(DATA_blue_flag.POP10);
DATA_blue_flag.TC = double(DATA_blue_flag.TC);
DATA_blue_flag.Comp = categorical(DATA_blue_flag.Comp);
DATA_blue_flag.Country = categorical(DATA_blue_flag.Country);
DATA_blue_flag.concEC = double(DATA_blue_flag.concEC);
DATA_blue_flag.concIE = double(DATA_blue_flag.concIE);
DATA_blue_flag.Denmark = (DATA_blue_flag.Country=="DK");
DATA_blue_flag.Estonia = (DATA_blue_flag.Country=="EE");
DATA_blue_flag.Finland = (DATA_blue_flag.Country=="FI");
DATA_blue_flag.Germany = (DATA_blue_flag.Country=="DE");
DATA_blue_flag.Latvia = (DATA_blue_flag.Country=="LV");
DATA_blue_flag.Lithuania = (DATA_blue_flag.Country=="LT");
DATA_blue_flag.Poland = (DATA_blue_flag.Country=="PL");
DATA_blue_flag.Sweden = (DATA_blue_flag.Country=="SE");

DATA_blue_flag.POP3(DATA_blue_flag.POP3==0)=1;
DATA_blue_flag.POP6(DATA_blue_flag.POP6==0)=1;
DATA_blue_flag.POP10(DATA_blue_flag.POP10==0)=1;

DATA_blue_flag.concEC(DATA_blue_flag.concEC==0)=1;
DATA_blue_flag.concIE(DATA_blue_flag.concIE==0)=1;

DATA_blue_flag.log_POP3 = log(DATA_blue_flag.POP3);
DATA_blue_flag.log_POP6 = log(DATA_blue_flag.POP6);
DATA_blue_flag.log_POP10 = log(DATA_blue_flag.POP10);

DATA_blue_flag.sqrt_POP3 = sqrt(DATA_blue_flag.POP3);
DATA_blue_flag.sqrt_POP6 = sqrt(DATA_blue_flag.POP6);
DATA_blue_flag.sqrt_POP10 = sqrt(DATA_blue_flag.POP10);

DATA_blue_flag.sq_POP3 = (DATA_blue_flag.POP3).^2;
DATA_blue_flag.sq_POP6 = (DATA_blue_flag.POP6).^2;
DATA_blue_flag.sq_POP10 = (DATA_blue_flag.POP10).^2;


DATA_blue_flag.log_concEC = log(DATA_blue_flag.concEC);
DATA_blue_flag.log_concIE = log(DATA_blue_flag.concIE);

DATA_blue_flag.sqrt_concEC = sqrt(DATA_blue_flag.concEC);
DATA_blue_flag.sqrt_concIE = sqrt(DATA_blue_flag.concIE);

DATA_blue_flag.sq_concEC = (DATA_blue_flag.concEC).^2;
DATA_blue_flag.sq_concIE = (DATA_blue_flag.concIE).^2;

DATA_blue_flag.Comp1 = (DATA_blue_flag.Comp=="1");
DATA_blue_flag.Comp2 = (DATA_blue_flag.Comp=="2");
DATA_blue_flag.Comp3 = (DATA_blue_flag.Comp=="3");
DATA_blue_flag.Comp4 = (DATA_blue_flag.Comp=="4");



% Rana, V., Milke, J., & Gałczyńska, M. (2021). Inorganic and Organic Pollutants in Baltic Sea Region and Feasible Circular Economy Perspectives for Waste Management: A.

% weights (coastline)
% Denmark	7474
% Estonia	3794
% Finland	1126
% Germany	2389
% Latvia	498
% Lithuania	90
% Poland	770
% Sweden	3218
coastline_length = [7474;3794;1126;2389;498;90;770;3218];
coastline_length = coastline_length./sum(coastline_length);
weights_coastline = string(DATA_blue_flag.Country);
weights_coastline(weights_coastline=="DK")=coastline_length(1)/sum(coastline_length)/sum(weights_coastline=="DK");
weights_coastline(weights_coastline=="EE")=coastline_length(2)/sum(coastline_length)/sum(weights_coastline=="EE");
weights_coastline(weights_coastline=="FI")=coastline_length(3)/sum(coastline_length)/sum(weights_coastline=="FI");
weights_coastline(weights_coastline=="DE")=coastline_length(4)/sum(coastline_length)/sum(weights_coastline=="DE");
weights_coastline(weights_coastline=="LV")=coastline_length(5)/sum(coastline_length)/sum(weights_coastline=="LV");
weights_coastline(weights_coastline=="LT")=coastline_length(6)/sum(coastline_length)/sum(weights_coastline=="LT");
weights_coastline(weights_coastline=="PL")=coastline_length(7)/sum(coastline_length)/sum(weights_coastline=="PL");
weights_coastline(weights_coastline=="SE")=coastline_length(8)/sum(coastline_length)/sum(weights_coastline=="SE");
weights_coastline = double(weights_coastline);
weights_coastline_normalized = weights_coastline/sum(weights_coastline) * length(weights_coastline);


reg0 = fitlm(DATA_blue_flag,'Asc_choice~Blue_flag+Country-1',Weights=weights_coastline)
reg1 = fitlm(DATA_blue_flag,'Asc_choice~Blue_flag+POP3+POP6+POP10+Comp+concEC+concIE+Denmark+Estonia+Poland+Finland+Germany+Latvia+Lithuania+Sweden-1',Weights=weights_coastline)
reg2 = fitlm(DATA_blue_flag,'Asc_choice~Blue_flag+log_POP3+log_POP6+log_POP10+Comp+concEC+concIE+Denmark+Estonia+Poland+Finland+Germany+Latvia+Lithuania+Sweden-1',Weights=weights_coastline)
reg3 = fitlm(DATA_blue_flag,'Asc_choice~Blue_flag+sqrt_POP3+sqrt_POP6+sqrt_POP10+Comp+concEC+concIE+Denmark+Estonia+Poland+Finland+Germany+Latvia+Lithuania+Sweden-1',Weights=weights_coastline)
reg4 = fitlm(DATA_blue_flag,'Asc_choice~Blue_flag+sq_POP3+sq_POP6+sq_POP10+Comp+concEC+concIE+Denmark+Estonia+Poland+Finland+Germany+Latvia+Lithuania+Sweden-1',Weights=weights_coastline)
reg5 = fitlm(DATA_blue_flag,'Asc_choice~Blue_flag+POP3+Comp+concEC+concIE+Denmark+Estonia+Poland+Finland+Germany+Latvia+Lithuania+Sweden-1',Weights=weights_coastline)
reg6 = fitlm(DATA_blue_flag,'Asc_choice~Blue_flag+POP3+Blue_flag:POP3+Comp+concEC+concIE+Denmark+Estonia+Poland+Finland+Germany+Latvia+Lithuania+Sweden-1',Weights=weights_coastline)
reg7 = fitlm(DATA_blue_flag,'Asc_choice~Blue_flag+log_POP3+Blue_flag:log_POP3+Comp+concEC+concIE+Denmark+Estonia+Poland+Finland+Germany+Latvia+Lithuania+Sweden-1',Weights=weights_coastline)

DATA_blue_flag.POP3 = DATA_blue_flag.POP3./1000;
DATA_blue_flag.concEC = DATA_blue_flag.concEC./1000;
DATA_blue_flag.concIE = DATA_blue_flag.concIE./1000;
reg5 = fitlm(DATA_blue_flag,'Asc_choice~Blue_flag+POP3+Comp+concEC+concIE+Denmark+Estonia+Poland+Finland+Germany+Latvia+Lithuania+Sweden-1',Weights=weights_coastline)


reg1.Rsquared.Ordinary
reg2.Rsquared.Ordinary
reg3.Rsquared.Ordinary
reg4.Rsquared.Ordinary
reg5.Rsquared.Ordinary
reg6.Rsquared.Ordinary
reg7.Rsquared.Ordinary


reg5_diagnostics = [reg5.MSE,"MSE";reg5.RMSE,"RMSE";reg5.LogLikelihood,"LogLikelihood";reg5.DFE,"DFE";reg5.SSE,"SSE";reg5.SST,"SST";reg5.SSR,"SSR";reg5.Rsquared.Ordinary,"Rsquared Ordinary";reg5.Rsquared.Adjusted,"Rsquared Adjusted";reg5.ModelCriterion.AIC,"AIC";reg5.ModelCriterion.AICc,"AICc";reg5.ModelCriterion.BIC,"BIC";reg5.ModelCriterion.CAIC,"CAIC";reg5.NumPredictors,"NumPredictors";reg5.NumObservations,"NumObservations"];

DK_s = DATA_blue_flag(DATA_blue_flag.Country ~= "DK", :);
EE_s = DATA_blue_flag(DATA_blue_flag.Country ~= "EE", :);
FI_s = DATA_blue_flag(DATA_blue_flag.Country ~= "FI", :);
DE_s = DATA_blue_flag(DATA_blue_flag.Country ~= "DE", :);
LV_s = DATA_blue_flag(DATA_blue_flag.Country ~= "LV", :);
LT_s = DATA_blue_flag(DATA_blue_flag.Country ~= "LT", :);
PL_s = DATA_blue_flag(DATA_blue_flag.Country ~= "PL", :);
SE_s = DATA_blue_flag(DATA_blue_flag.Country ~= "SE", :);

reg_withoutDK = fitlm(DATA_blue_flag,'Asc_choice~Blue_flag+POP3+Comp+concEC+concIE+Estonia+Finland+Germany+Latvia+Lithuania+Poland+Sweden-1',Weights=weights_coastline)
reg_withoutEE = fitlm(DATA_blue_flag,'Asc_choice~Blue_flag+POP3+Comp+concEC+concIE+Denmark+Finland+Germany+Latvia+Lithuania+Poland+Sweden-1',Weights=weights_coastline)
reg_withoutFI = fitlm(DATA_blue_flag,'Asc_choice~Blue_flag+POP3+Comp+concEC+concIE+Denmark+Estonia+Germany+Latvia+Lithuania+Poland+Sweden-1',Weights=weights_coastline)
reg_withoutDE = fitlm(DATA_blue_flag,'Asc_choice~Blue_flag+POP3+Comp+concEC+concIE+Denmark+Estonia+Finland+Latvia+Lithuania+Poland+Sweden-1',Weights=weights_coastline)
reg_withoutLV = fitlm(DATA_blue_flag,'Asc_choice~Blue_flag+POP3+Comp+concEC+concIE+Denmark+Estonia+Finland+Germany+Lithuania+Poland+Sweden-1',Weights=weights_coastline)
reg_withoutLT = fitlm(DATA_blue_flag,'Asc_choice~Blue_flag+POP3+Comp+concEC+concIE+Denmark+Estonia+Finland+Germany+Latvia+Poland+Sweden-1',Weights=weights_coastline)
reg_withoutPL = fitlm(DATA_blue_flag,'Asc_choice~Blue_flag+POP3+Comp+concEC+concIE+Denmark+Estonia+Finland+Germany+Latvia+Lithuania+Sweden-1',Weights=weights_coastline)
reg_withoutSE = fitlm(DATA_blue_flag,'Asc_choice~Blue_flag+POP3+Comp+concEC+concIE+Denmark+Estonia+Finland+Germany+Latvia+Lithuania+Poland-1',Weights=weights_coastline)


cd('C:\Users\Admin\Documents\Baltic\Blue_flag_regression')

writetable(DATA_blue_flag,'DATA_blue_flag_13_04.xlsx','sheet','data','Range','A1')

writetable([reg0.CoefficientNames',reg0.Coefficients],'lm_results_13_04.xlsx','sheet','reg0','Range','A1')
writetable([reg1.CoefficientNames',reg1.Coefficients],'lm_results_13_04.xlsx','sheet','reg1','Range','A1')
writetable([reg2.CoefficientNames',reg2.Coefficients],'lm_results_13_04.xlsx','sheet','reg2','Range','A1')
writetable([reg3.CoefficientNames',reg3.Coefficients],'lm_results_13_04.xlsx','sheet','reg3','Range','A1')
writetable([reg4.CoefficientNames',reg4.Coefficients],'lm_results_13_04.xlsx','sheet','reg4','Range','A1')
writetable([reg5.CoefficientNames',reg5.Coefficients],'lm_results_13_04.xlsx','sheet','reg5','Range','A1')
writematrix(reg5_diagnostics,'lm_results_13_04.xlsx','sheet','reg5_diagnostics','Range','A1')
writetable([reg6.CoefficientNames',reg6.Coefficients],'lm_results_13_04.xlsx','sheet','reg6','Range','A1')
writetable([reg7.CoefficientNames',reg7.Coefficients],'lm_results_13_04.xlsx','sheet','reg7','Range','A1')
writetable([reg_withoutDK.CoefficientNames',reg_withoutDK.Coefficients],'lm_results_13_04.xlsx','sheet','reg_withoutDK','Range','A1')
writetable([reg_withoutEE.CoefficientNames',reg_withoutEE.Coefficients],'lm_results_13_04.xlsx','sheet','reg_withoutEE','Range','A1')
writetable([reg_withoutFI.CoefficientNames',reg_withoutFI.Coefficients],'lm_results_13_04.xlsx','sheet','reg_withoutFI','Range','A1')
writetable([reg_withoutDE.CoefficientNames',reg_withoutDE.Coefficients],'lm_results_13_04.xlsx','sheet','reg_withoutDE','Range','A1')
writetable([reg_withoutLV.CoefficientNames',reg_withoutLV.Coefficients],'lm_results_13_04.xlsx','sheet','reg_withoutLV','Range','A1')
writetable([reg_withoutLT.CoefficientNames',reg_withoutLT.Coefficients],'lm_results_13_04.xlsx','sheet','reg_withoutLT','Range','A1')
writetable([reg_withoutPL.CoefficientNames',reg_withoutPL.Coefficients],'lm_results_13_04.xlsx','sheet','reg_withoutPL','Range','A1')
writetable([reg_withoutSE.CoefficientNames',reg_withoutSE.Coefficients],'lm_results_13_04.xlsx','sheet','reg_withoutSE','Range','A1')