% BalticApp
% Model for DE (Germany)

% Count data
clear
clc

population = 67210000;
% New data with weights
rng(179424673);
global B_backup; % this one is for storing B in case iterations are interrupted with ctrl-c

%% Data transformation 
cd('C:\Users\Admin\Documents\Baltic')
load('MXL\DE_mxl_cs.mat');
load('DATA_trips.mat');

EstimOpt.NP = DATA.NP; 
EstimOpt.NCT = 1; % Number of choice tasks per person 
EstimOpt.NAlt = DATA.NAlt;

% Estimation
% INPUT.Xa = [DATA.envbn, DATA.male, DATA.incn, DATA.hhkids, DATA.age, DATA.edu == 2, DATA.edu == 3, DATA.edu == 4, DATA.bocc] ;


INPUT.Xa = [DATA.MALE, DATA.HINC, DATA.HHKIDS, DATA.age, DATA.EDU == 2, DATA.EDU == 3, DATA.EDU == 4, DATA.bocc] ;
INPUT.Xa = INPUT.Xa(1:EstimOpt.NAlt:end,:);









INPUT.Xa = [INPUT.Xa(:,1), INPUT.Xa(:,2)/10000,  INPUT.Xa(:,3), INPUT.Xa(:,4)/100,  INPUT.Xa(:,5:8)];
x_aux = join(dataset(DATA.id),dataset(DATA_trips.ID, DATA_trips.trips_new2));
DATA.trips_v2 = x_aux.Var2;

trips_censoring = x_aux.Var2(1:EstimOpt.NAlt:end);
trips_previous = DATA.Trips(1:EstimOpt.NAlt:end);
trips_censoring(trips_censoring < trips_previous) = DATA.Trips(trips_censoring < trips_previous);
test_censoring = [length(trips_censoring),sum(isnan(trips_censoring)),sum(trips_censoring>=30),sum(trips_censoring>=40),sum(trips_censoring>=50),sum(trips_censoring>=60),sum(trips_censoring>=70),sum(trips_censoring>=80),sum(trips_censoring>=90),sum(trips_censoring>=100)];

DATA.trips_v2(isnan(DATA.trips_v2))=0;
DATA.trips_v2(DATA.trips_v2 < DATA.Trips) = DATA.Trips(DATA.trips_v2 < DATA.Trips);

INPUT.Y = DATA.trips_v2(1:EstimOpt.NAlt:end);

% mean(INPUT.Y>=DATA.Trips(1:EstimOpt.NAlt:end)) %0.96

EstimOpt.NamesA = {'Cons.'; 'Consumer surplus/100'; 'Male'; 'Income/10000'; 'Hhkids'; 'Age/100'; 'Edu == 2'; 'Edu == 3'; 'Edu == 4'; 'BOCC'};
EstimOpt.NamesZIP = {'Cons.';  'Male'; 'Income/10000'; 'Hhkids'; 'Age/100'; 'Edu == 2'; 'Edu == 3'; 'Edu == 4'; 'BOCC'};
% EstimOpt.NamesA = {'Cons.'; 'Consumer surplus/100'; 'Male'; 'Income/10000'; 'Hhkids'; 'Age/100'; 'Edu == 2'; 'Edu == 3'; 'Edu == 4'; 'BOCC'; 'CS/100 X Male'; 'CS/100 X Income/10000'; 'CS/100 X Hhkids'; 'CS/100 X Age/100'; 'CS/100 X Edu == 2'; 'CS/100 X Edu == 3'; 'CS/100 X Edu == 4'; 'CS/100 X BOCC'};
% EstimOpt.NamesZIP = {'Cons.'; 'Consumer surplus/100'; 'Male'; 'Income/10000'; 'Hhkids'; 'Age/100'; 'Edu == 2'; 'Edu == 3'; 'Edu == 4'; 'BOCC'; 'CS/100 X Male'; 'CS/100 X Income/10000'; 'CS/100 X Hhkids'; 'CS/100 X Age/100'; 'CS/100 X Edu == 2'; 'CS/100 X Edu == 3'; 'CS/100 X Edu == 4'; 'CS/100 X BOCC'};

W = reshape(DATA.Weights_new, [EstimOpt.NAlt, EstimOpt.NP]);
INPUT.W = W(2,:)';
INPUT.W = EstimOpt.NP*INPUT.W/sum(INPUT.W);

%% Estimation
% Poisson 


TC = reshape(DATA.TC, [EstimOpt.NAlt, EstimOpt.NP]);
choice = reshape(DATA.Choice, [EstimOpt.NAlt, EstimOpt.NP]);
mTC = mean(TC,1)';
minTC = min(TC)';
cTC =  NaN(EstimOpt.NP,1);
for i = 1:EstimOpt.NP
    if sum(choice(:,i)) == 0
       cTC(i) = mean(TC(:,i)); 
    else
        cTC(i) = TC(choice(:,i) == 1,i);
    end
end


INPUT.Xa = [ones(EstimOpt.NP,1), DATA.CS, INPUT.Xa];
%INPUT.Xa = [INPUT.Xa, INPUT.Xa(:,3:10) .*DATA.CS];
EstimOpt.NB = 0;
INPUT.MissingInd = isnan(INPUT.Y);
EstimOpt.Offset = ones(EstimOpt.NP,1);

[INPUT, Results, EstimOpt, OptimOpt] = DataCleanCDM(INPUT,EstimOpt);

Results.POISS = POISS(INPUT,Results, EstimOpt, OptimOpt);

% NB2
B_backup = [Results.POISS.bhat; 0];
EstimOpt.NB = 1;
Results.NB = POISS(INPUT,Results, EstimOpt, OptimOpt);

% NBP
EstimOpt.NB = 2;
B_backup = [Results.NB.bhat;2];
EstimOpt.HessEstFix = 1;
Results.NBP = POISS(INPUT,Results, EstimOpt, OptimOpt);

% Censoring
EstimOpt.Censored = 31;
INPUT.Y(INPUT.Y > EstimOpt.Censored-1) = EstimOpt.Censored;
Results.NBP = POISS(INPUT,Results, EstimOpt, OptimOpt);

CStrip =  100/Results.NBP.bhat(2);
Lambda = exp(INPUT.Xa*B_backup(1:EstimOpt.NVarA));
CS =  100*Lambda/Results.NBP.bhat(2);
CSAvg = sum(CS.*INPUT.W)/sum(INPUT.W);
LambdaAvg = sum(Lambda.*INPUT.W)/sum(INPUT.W);
TripsAvg = sum(INPUT.Y.*INPUT.W)/sum(INPUT.W);
Check = [CStrip, LambdaAvg, TripsAvg, CSAvg] % 

% Mean CS - per trip (EUR)
hfun = @(b) 100/b(2);
[CSpertrip, SE1] = deltamethod(hfun, Results.NBP.bhat, Results.NBP.ihess)

% Predicted number of trips
hfun = @(b) sum(exp(INPUT.Xa*b(1:EstimOpt.NVarA)).*INPUT.W)/sum(INPUT.W);
[CSpredtrips, SE3] = deltamethod(hfun, Results.NBP.bhat, Results.NBP.ihess)

% Mean CS - all trips (EUR)
hfun = @(b) 100*sum(exp(INPUT.Xa*b(1:EstimOpt.NVarA)).*INPUT.W/sum(INPUT.W))/b(2);
[CStot, SE2] = deltamethod(hfun, Results.NBP.bhat, Results.NBP.ihess)

% CSpertrip*CSpredtrips-CStot
% X_output_delta = [CSpertrip;SE1;CSpredtrips;SE3;CStot;SE2];

%% Welfera loss for each site

DATA.blue_flag_increase = DATA.blue_flag;
DATA.blue_flag_increase(DATA.blue_flag_increase==0)=0.728057457333693;
DATA.blue_flag_increase(DATA.blue_flag_increase==1)=0;

NP = EstimOpt.NP;
Results_choice = load('MXL\DE_mxl_cs.mat');

% some sites were not visited
sum(Results_choice.DATA.DEMV_PR_1_0201) %1
sum(Results_choice.DATA.DEMV_PR_1_0222) %5
sum(Results_choice.DATA.DEMV_PR_1_0279) %15
sum(Results_choice.DATA.DEMV_PR_1_0777) %20
sum(Results_choice.DATA.DESH_PR_0007) %26
sum(Results_choice.DATA.DESH_PR_0092) %30
sum(Results_choice.DATA.DESH_PR_0146) %33
sum(Results_choice.DATA.DESH_PR_0290) %37

missing_site = ones(38*1000,1);
missing_site(DATA.SiteID=="DEMV_PR_1_0201")=0;
missing_site(DATA.SiteID=="DEMV_PR_1_0222")=0;
missing_site(DATA.SiteID=="DEMV_PR_1_0279")=0;
missing_site(DATA.SiteID=="DEMV_PR_1_0777")=0;
missing_site(DATA.SiteID=="DESH_PR_0007")=0;
missing_site(DATA.SiteID=="DESH_PR_0092")=0;
missing_site(DATA.SiteID=="DESH_PR_0146")=0;
missing_site(DATA.SiteID=="DESH_PR_0290")=0;

TC_aux = DATA.TC(logical(missing_site));
DATA.blue_flag_increase = DATA.blue_flag_increase(logical(missing_site));

B_mxl = Results_choice.Results.MNL.bhat;
EstimOpt.NAlt = 30;

Xa = [zeros(1,EstimOpt.NAlt-1);eye(EstimOpt.NAlt-1)];
Xa = [repmat(Xa, NP, 1), -TC_aux/100];

NSim = 10000;
cs_sim = NaN(NP,NSim);
cs_sim_site = NaN(NP,EstimOpt.NAlt, NSim);
cs_sim_bf = NaN(NP,NSim);

%mu_lognorm = B_mxl(end/2);
%sigma_lognorm = abs(B_mxl(end));

% Tutaj NSim x NP
cost_aux = zeros([NSim, NP])+ B_mxl(end);
cost_aux_expanded = reshape(cost_aux, [1, NSim, NP]);

vec_bhat = B_mxl(1:EstimOpt.NAlt); %parameters

tic
Fit = reshape(Xa(:,1:end)*vec_bhat(1:end),[EstimOpt.NAlt, NP]);
Fit_bf = reshape(DATA.blue_flag_increase+(Xa(:,1:end)*vec_bhat(1:end)),[EstimOpt.NAlt, NP]);

%Cost = reshape(Xa(:,end),[EstimOpt.NAlt, NP]);
Vec_alt = 1:EstimOpt.NAlt;
for i = 1:NP
    %CostFit = Cost(:,i).*lognorm_random_expanded(:,:,i); % NAlt x NSim
    Fit_i = exp(Fit(:,i)); % NAlt x NSim
    Fit_i_bf = exp(Fit_bf(:,i)); % NAlt x NSim
    esum = max(sum(Fit_i,1), realmin); % to avoid infinite values
    cs_sim(i,:) = log(esum)./cost_aux_expanded(:,:,i);
    esum_bf = max(sum(Fit_i_bf,1), realmin); % to avoid infinite values
    cs_sim_bf(i,:) = log(esum_bf)./cost_aux_expanded(:,:,i);
    for j = 1:EstimOpt.NAlt
        esum_j = max(sum(Fit_i(Vec_alt ~= j,:),1), realmin); % to avoid infinite values
        cs_sim_site(i,j,:) = reshape(log(esum_j)./cost_aux_expanded(:,:,i), [1,1, NSim]);
    end        
end

CS_mxl_median_old = median(cs_sim,2);
CS_mxl_median_bf = median(cs_sim_bf,2);
mean(CS_mxl_median_bf  - CS_mxl_median_old)

CS_med_site = median(cs_sim_site,3); % NP x NAlt
CS_med_site_mean = mean(CS_med_site,1);

% Before blue_flag
% Lambda = exp(INPUT.Xa*B_backup(1:EstimOpt.NVarA));
Xa_tmp = INPUT.Xa;
mean(Xa_tmp(:,2) - CS_mxl_median_old)
% pause;

% W: Tutaj liczę CS używając tego CS_mxl_median_old
    % To powinno byc to samo co mamy w INPUT.Xa(:,2), ale ze wzgledu na blad
    % symulacji moze sie troche roznic
Xa_tmp(:,2) = CS_mxl_median_old;
Lambda = exp(Xa_tmp*B_backup(1:EstimOpt.NVarA));
CS =  100*Lambda/Results.NBP.bhat(2);
% To jest to co mielismy wczesniej
CS_old = 100*exp(INPUT.Xa*B_backup(1:EstimOpt.NVarA))/Results.NBP.bhat(2);

% After blue_flag
Xa_tmp = INPUT.Xa;
Xa_tmp(:,2) = CS_mxl_median_bf;
Lambda2 = exp(Xa_tmp*B_backup(1:EstimOpt.NVarA));
CS_bf =  100*Lambda2/Results.NBP.bhat(2);

% Change
Diff = CS_bf - CS;
CS_bf_diff = sum(Diff.*INPUT.W/sum(INPUT.W))
mCS = sum(CS.*INPUT.W/sum(INPUT.W));
CS_bf_diff/mCS
toc

%% Results
results_cs = [population*sum(CS.*INPUT.W/sum(INPUT.W))/1000000000;population*sum(CS_bf.*INPUT.W/sum(INPUT.W))/1000000000;CS_bf_diff/mCS];

cs_1 = population*CS.*INPUT.W/1000000000;
se_1 = std(cs_1)/sqrt(sum(INPUT.W));

cs_2 = population*CS_bf.*INPUT.W/1000000000;
se_2 = std(cs_2)/sqrt(sum(INPUT.W));

cs_3 = cs_2-cs_1;
se_3 = std(cs_3)/sqrt(sum(INPUT.W));

results_cs_new = [population*sum(CS.*INPUT.W/sum(INPUT.W))/1000000000;se_1;...
    population*sum(CS_bf.*INPUT.W/sum(INPUT.W))/1000000000;se_2;...
    mean(cs_3);se_3;...
    CS_bf_diff/mCS];

cd('Count_ci_12.04')
writematrix(results_cs_new,'count_results_ci_13_04.xlsx','sheet','DE','Range','A1')

%% Welfare
Welfare_loss = zeros(EstimOpt.NP, EstimOpt.NAlt);
Welfare_CS = zeros(EstimOpt.NP, EstimOpt.NAlt); % WZ
Welfate_CS_j = zeros(EstimOpt.NP, EstimOpt.NAlt); % WZ

for j = 1:EstimOpt.NAlt
    Xa_tmp = INPUT.Xa;
    Xa_tmp(:,2) = CS_med_site(:,j);  
    Lambda = exp(Xa_tmp*Results.NBP.bhat(1:EstimOpt.NVarA));
    CS_j = 100*Lambda/Results.NBP.bhat(2);
    Welfare_loss(:,j) =  CS - CS_j;
    Welfare_CS(:,j) = CS;
    Welfate_CS_j(:,j) = CS_j;
end
Mean_Welfare_loss = sum(Welfare_loss.*INPUT.W,1)/sum(INPUT.W); % To trzeba nanieść na mapę
Mean_Welfare_CS = sum(Welfare_CS.*INPUT.W,1)/sum(INPUT.W);
Mean_Welfare_CS_j = sum(Welfate_CS_j.*INPUT.W,1)/sum(INPUT.W);

X_output = [Results.NBP.DetailsA; Results.NBP.DetailsNB; Check;...
    CSpertrip,CSpredtrips,CStot,NaN;...
    SE1,SE3,SE2,NaN;...
    NaN,NaN,NaN,NaN;...
    Results.NBP.stats(1),0,0,0;...
    Results.NBP.stats(2),0,0,0;...
    Results.NBP.stats(3),0,0,0;...
    Results.NBP.stats(4),0,0,0;...
    Results.NBP.stats(5),0,0,0;...
    Results.NBP.stats(6),0,0,0;...
    Results.NBP.stats(7),0,0,0;...
    Results.NBP.stats(8),0,0,0;...
    Results.NBP.stats(9),0,0,0;
    NaN,NaN,NaN,NaN;...
    EstimOpt.NAlt,0,0,0;...
    population,0,0,0;...
    mean((Mean_Welfare_loss.*population)'),0,0,0;...
    std((Mean_Welfare_loss.*population)'),0,0,0;...
    min((Mean_Welfare_loss.*population)'),0,0,0;...
    max((Mean_Welfare_loss.*population)'),0,0,0];

site_names = DATA.SiteID(1:38);
site_names(site_names=="DEMV_PR_1_0201")=[];
site_names(site_names=="DEMV_PR_1_0222")=[];
site_names(site_names=="DEMV_PR_1_0279")=[];
site_names(site_names=="DEMV_PR_1_0777")=[];
site_names(site_names=="DESH_PR_0007")=[];
site_names(site_names=="DESH_PR_0092")=[];
site_names(site_names=="DESH_PR_0146")=[];
site_names(site_names=="DESH_PR_0290")=[];

X_output_welfare = [site_names,string((Mean_Welfare_loss.*population)')];

writematrix(X_output,'count_results_ci_13_04_X_output.xlsx','sheet','DE','Range','A1')
writematrix(X_output_welfare,'count_results_ci_13_04_X_output_welfare.xlsx','sheet','DE','Range','A1')

save 'DE_count.mat' DATA Results X_output X_output_welfare results_cs