function [h, SE] = deltamethod(hfun, b0, I)

% hfun in function to be evaluated
% b0 is parameters' vector
% I is variance covariance matrix

h = feval(@(b) hfun(b), b0);
H = jacobianest(@(b) hfun(b), b0);
SE = sqrt(H*I*H');