% BalticApp
% DATA transform (new trips count variable)

% Count data
clear
clc

%% Trips variable to compare
cd('C:\Users\wzawadzki\Documents\Baltic\DATA')

load('DE_updated.mat');
DE_aux(:,1) = DATA.id;
DE_aux(:,2) = DATA.Trips;
clear DATA

DATA = load('DK.mat');
DK_aux(:,1) = DATA.id;
DK_aux(:,2) = DATA.trips;
clear DATA

DATA = load('EE.mat');
EE_aux(:,1) = DATA.id;
EE_aux(:,2) = DATA.trips;
clear DATA

load('FI_updated.mat');
FI_aux(:,1) = DATA.id;
FI_aux(:,2) = DATA.trips;
clear DATA

DATA = load('LT.mat');
LT_aux(:,1) = DATA.id;
LT_aux(:,2) = DATA.trips;
clear DATA;

DATA = load('LV.mat');
LV_aux(:,1) = DATA.id;
LV_aux(:,2) = DATA.trips;
clear DATA:

DATA = load('PL.mat');
PL_aux(:,1) = DATA.id;
PL_aux(:,2) = DATA.trips;
clear DATA

DATA = load('SE.mat');
SE_aux(:,1) = DATA.id;
SE_aux(:,2) = DATA.trips;
clear DATA

id_aux = [DE_aux; DK_aux; EE_aux; FI_aux; LT_aux; LV_aux; PL_aux; SE_aux];
clear DE_aux DK_aux EE_aux FI_aux LT_aux LV_aux PL_aux SE_aux

%% Preparing to calculate trips_new

cd('C:\Users\wzawadzki\Documents\Baltic') % Directory to the folder with data
DATA = readtable('BALT.DATA.01.xls');
DATA.country_cat = string(DATA.ID);
DATA.country_cat(DATA.DE==1)="DE";
DATA.country_cat(DATA.DK==1)="DK";
DATA.country_cat(DATA.EE==1)="EE";
DATA.country_cat(DATA.FI==1)="FI";
DATA.country_cat(DATA.LIT==1)="LIT";
DATA.country_cat(DATA.LV==1)="LV";
DATA.country_cat(DATA.PL==1)="PL";
DATA.country_cat(DATA.RUC==1)="RUC";
DATA.country_cat(DATA.RUO==1)="RUO";
DATA.country_cat(DATA.SE==1)="SE";

DATA_trips.ID = DATA.ID;
DATA_trips.country_cat = DATA.country_cat;
DATA_trips.DAYSS = DATA.DAYSS;
DATA_trips.DAYSW = DATA.DAYSW;
DATA_trips.VISLD = DATA.VISLD;
DATA_trips.VISLH = DATA.VISLH;


% Liczba dni (DAYS) jaka respondent spedzil nad Baltykiem = DAYSS + DAYSW
DATA_trips.DAYSS(DATA_trips.DAYSS==-999)=NaN;
DATA_trips.DAYSW(DATA_trips.DAYSW==-999)=NaN;
DATA_trips.DAYS = nansum([DATA_trips.DAYSS,DATA_trips.DAYSW],2);

% Ile dni/godzin (w przypadku wizyt jednodniowych), ktos spedzil nad Baltykiem podczas swojej ostatniej podrozy
DATA_trips.VISLD(DATA_trips.VISLD==-999)=NaN;
DATA_trips.VISLH(DATA_trips.VISLH==-999)=NaN;
DATA_trips.VISLD_h = 24*DATA_trips.VISLD;



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1) i 2)
% 1) VIS1 & trips_new1 oraz 2) VIS2 & trips_new2 roznia sie uzyciem round w:
% DATA_trips.VIS1 = round(DATA_trips.VIS1/24);
% DATA_trips.VIS2 = (DATA_trips.VIS2/24);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 1)
% Czas ostatniej wizyty w godzinach: VISLD*24 + VISLH = VISLD_h + VISLH
DATA_trips.VIS1 = nansum([DATA_trips.VISLD_h,DATA_trips.VISLH],2);

% Liczba dni ostatniej wizyty (jesli wizyta trwala mniej niz 24h to zaokraglamy w gore do 1 dnia)
DATA_trips.VIS1(DATA_trips.VIS1<=24 & DATA_trips.VIS1>0)=24;
DATA_trips.VIS1 = round(DATA_trips.VIS1/24); % ROZNICA: uzycie round

% Wyliczenie liczby wizyt (liczba dni spedzona nad baltykiem / czas ostatniej wizyty)
DATA_trips.trips_new1 = round(DATA_trips.DAYS./DATA_trips.VIS1);
DATA_trips.trips_new1(DATA_trips.VIS1==0)=NaN;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 2)
% Czas ostatniej wizyty w godzinach: VISLD*24 + VISLH = VISLD_h + VISLH
DATA_trips.VIS2 = nansum([DATA_trips.VISLD_h,DATA_trips.VISLH],2);

% Liczba dni ostatniej wizyty (jesli wizyta trwala mniej niz 24h to zaokraglamy w gore do 1 dnia)
DATA_trips.VIS2(DATA_trips.VIS2<=24 & DATA_trips.VIS2>0)=24;
DATA_trips.VIS2 = (DATA_trips.VIS2/24); % ROZNICA: bez round

% Wyliczenie liczby wizyt (liczba dni spedzona nad baltykiem / czas ostatniej wizyty)
DATA_trips.trips_new2 = round(DATA_trips.DAYS./DATA_trips.VIS2);
DATA_trips.trips_new2(DATA_trips.VIS2==0)=NaN;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


% sum(DATA_trips.trips_new1==DATA_trips.trips_new2) % 3800
% sum(isnan(DATA_trips.trips_new1)) % 5825
% sum(isnan(DATA_trips.trips_new2)) % 5825
% difference: 9627-5825-3800=2

  
id_aux_unique = unique(id_aux, 'rows');
%old_trips_data = dataset(id_aux_unique(:,1), id_aux_unique(:,2));
%id_data = dataset(DATA_trips.ID);

trips_aux = join(dataset(id_aux_unique(:,1), id_aux_unique(:,2)), dataset(DATA_trips.ID),'type','rightouter','mergekeys',true);
DATA_trips.trips_old = trips_aux.Var2;

clear id_aux id_aux_unique trips_aux

table_check = table(DATA_trips.ID, DATA_trips.country_cat, DATA_trips.DAYSS, DATA_trips.DAYSW, DATA_trips.DAYS, DATA_trips.VISLD, DATA_trips.VISLH, DATA_trips.VISLD_h, DATA_trips.VIS1, DATA_trips.trips_new1, DATA_trips.VIS2, DATA_trips.trips_new2, DATA_trips.trips_old);
table_check.Properties.VariableNames = {'ID','Country','DAYSS', 'DAYSW', 'DAYS', 'VISLD', 'VISLH', 'VISLD_h', 'VIS1', 'trips_new1', 'VIS2', 'trips_new2', 'trips_old'};

save 'DATA_trips.mat' DATA_trips
